unit uZellulaererAutomat;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    bEnde: TButton;
    bStart: TButton;
    Label1: TLabel;
    gAnzeige: TEdit;
    bStop: TButton;
    bNeustart: TButton;
    Timer1: TTimer;
    bEinzelschritt: TButton;
    bDiagramm: TButton;
    procedure bEndeClick(Sender: TObject);
    procedure bStartClick(Sender: TObject);
    procedure bStopClick(Sender: TObject);
    procedure bNeustartClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure bEinzelschrittClick(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure bDiagrammClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation
uses uWelt,uDiagramm;

{$R *.dfm}

const dt = 10;

var generation: integer = 0;

procedure init;
begin
generation := 0;
Form1.gAnzeige.text := IntToStr(generation);
welt.init;
end;

procedure TForm1.bEndeClick(Sender: TObject);
begin
halt
end;

procedure TForm1.bStartClick(Sender: TObject);
begin
Diagramm.init;
Timer1.Interval := dt;
end;

procedure TForm1.bStopClick(Sender: TObject);
begin
Timer1.Interval := 0;
end;

procedure TForm1.bNeustartClick(Sender: TObject);
begin
Init;
Diagramm.Init
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
welt.handle;
generation := generation + 1;
Form1.gAnzeige.text := IntToStr(generation);

end;

procedure TForm1.FormCreate(Sender: TObject);
begin
welt := twelt.create(Form1.canvas);
init;
end;

procedure TForm1.bEinzelschrittClick(Sender: TObject);
begin
welt.handle;
generation := generation + 1;
Form1.gAnzeige.text := IntToStr(generation);
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
init;
end;

procedure TForm1.bDiagrammClick(Sender: TObject);
begin
if Diagramm.Visible then Diagramm.Hide else Diagramm.show;
end;

initialization
randomize;


end.
