unit uWelt;

interface
uses Graphics,ExtCtrls,Controls,uAutomat;

const xmax = 49; ymax = 49;
      clOrange = 200 shl 8 + 255;

type
  tWelt = class
    public
    elemente: array[0..xmax,0..ymax] of tPartner;
    constructor create(canvas: tCanvas);
    procedure init;
    procedure handle;
    end;
    
var welt: tWelt;

implementation
uses uDiagramm;

constructor tWelt.create(canvas: tCanvas);
var i,j: integer;
begin
for i := 0 to xmax do
  for j := 0 to ymax do
    elemente[i,j] := tPartner.create(canvas,i,j);
end;

procedure twelt.init;
var i,j: integer;
begin
for i := 0 to xmax do
  for j := 0 to ymax do
    elemente[i,j].init;
end;

procedure tWelt.handle;
var i,j: integer;
begin
Diagramm.zeichne;
for i := 0 to xmax do
  for j := 0 to ymax do
    elemente[i,j].handelMitDenNachbarn;
for i := 0 to xmax do
  for j := 0 to ymax do
    elemente[i,j].wechseleZustand;
for i := 0 to xmax do
  for j := 0 to ymax do
    elemente[i,j].zustand := elemente[i,j].neuerZustand;
for i := 0 to xmax do
  for j := 0 to ymax do
    elemente[i,j].zeigeDich;
Diagramm.zeichne;
end;

end.
